LPDIRECTDRAW7			m_lpDD;
LPDIRECTDRAWSURFACE7	m_lpDDSFront;
LPDIRECTDRAWSURFACE7	m_lpDDSBack;


HRESULT CreateSurface( DWORD size_x, DWORD size_y, LPDIRECTDRAWSURFACE7 *surface ) {
	HRESULT				dwResult;
	DDSURFACEDESC2		ddsd;

	ZeroMemory( &ddsd, sizeof( ddsd ) );
	ddsd.dwSize			= sizeof( ddsd );
	ddsd.dwFlags		= DDSD_CAPS | DDSD_HEIGHT | DDSD_WIDTH;
	ddsd.dwWidth		= size_x;
	ddsd.dwHeight		= size_y;
	ddsd.ddsCaps.dwCaps	= DDSCAPS_OFFSCREENPLAIN;

	dwResult			= m_lpDD->CreateSurface( &ddsd, surface, NULL );
	return dwResult;
}

HRESULT InitDDraw( HWND hWnd, DWORD res_x, DWORD res_y, DWORD res_bit ) {
	m_lpDD			= NULL;
	m_lpDDSFront	= NULL;
	m_lpDDSBack		= NULL;

    HRESULT			dwResult;
	DDSURFACEDESC2	ddsd;
	DDSCAPS2		ddscaps;

    dwResult = DirectDrawCreateEx( NULL, ( void** )&m_lpDD, IID_IDirectDraw7, NULL );
    if ( dwResult != DD_OK ) {
        return dwResult;
    }

    dwResult = m_lpDD->SetCooperativeLevel( hWnd, DDSCL_EXCLUSIVE | 
													DDSCL_FULLSCREEN | 
													DDSCL_ALLOWREBOOT );
    if ( dwResult != DD_OK ) {
        return dwResult;
    }

    dwResult = m_lpDD->SetDisplayMode( res_x, res_y, res_bit, 0, 0 );
    if( dwResult != DD_OK ) {
        return dwResult;
    }

	ZeroMemory( &ddsd, sizeof( ddsd ) );
	ddsd.dwSize				= sizeof( ddsd );
	ddsd.dwFlags			=	DDSD_CAPS | 
								DDSD_BACKBUFFERCOUNT;
	ddsd.ddsCaps.dwCaps		=	DDSCAPS_PRIMARYSURFACE | 
								DDSCAPS_FLIP | 
								DDSCAPS_COMPLEX;
	ddsd.dwBackBufferCount	= 1	;

	dwResult = m_lpDD->CreateSurface( &ddsd, &m_lpDDSFront, NULL );
	if( dwResult != DD_OK ) {
		return dwResult;
	} 

    ZeroMemory( &ddscaps, sizeof( ddscaps ) );
    ddscaps.dwCaps = DDSCAPS_BACKBUFFER;

	dwResult = m_lpDDSFront->GetAttachedSurface( &ddscaps, &m_lpDDSBack );
    if( dwResult != DD_OK ) {
		return dwResult;
	}

	return dwResult;
}


void CleanDDraw() {
	if ( m_lpDD ) {
		if( m_lpDDSBack )	m_lpDDSBack->Release();
		if( m_lpDDSFront )	m_lpDDSFront->Release();		
		m_lpDDSFront	= NULL;
		m_lpDDSBack		= NULL;
		m_lpDD->RestoreDisplayMode();
		m_lpDD->Release();
		m_lpDD			= NULL;
	}
}

LRESULT WINAPI MsgProc( HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam ) {
    switch( msg ) {
        case WM_DESTROY:
            PostQuitMessage( 0 );
            return 0;

        case WM_PAINT:
            ValidateRect( hWnd, NULL );
            return 0;
    }

    return DefWindowProc( hWnd, msg, wParam, lParam );
}

void InitWin( WNDCLASSEX *wc, HWND *hWnd, char *class_name, char *win_name, int x1, int y1, int x2, int y2 ) {
    wc->cbSize			= sizeof(WNDCLASSEX);
	wc->style			= CS_CLASSDC;
	wc->lpfnWndProc		= MsgProc;
	wc->cbClsExtra		= 0L;
	wc->cbWndExtra		= 0L;
	wc->hInstance		= GetModuleHandle(NULL);
	wc->hIcon			= NULL;
	wc->hCursor			= NULL;
	wc->hbrBackground	= NULL;
	wc->lpszMenuName	= NULL;
	wc->lpszClassName	= class_name;
	wc->hIconSm			= NULL;

    RegisterClassEx(wc);

    ( *hWnd ) = CreateWindowEx( WS_EX_TOPMOST, class_name, win_name, 
                              WS_OVERLAPPEDWINDOW, x1, y1, x2, y2,
                              GetDesktopWindow(), NULL, wc->hInstance, NULL );
}

void CleanWin( WNDCLASSEX *wc, char *class_name ) {
	UnregisterClass( class_name, wc->hInstance );
}

LPDIRECTINPUT8 lpdi;
LPDIRECTINPUTDEVICE8  lpdiKeyboard; 

HRESULT InitDInput( HWND hwnd ) {
	HRESULT hr;
	hr = DirectInput8Create( GetModuleHandle(NULL), DIRECTINPUT_VERSION, IID_IDirectInput8, (void **) &lpdi, NULL);
	hr = lpdi->CreateDevice( GUID_SysKeyboard, &lpdiKeyboard, NULL ); 
	hr = lpdiKeyboard->SetCooperativeLevel( hwnd, DISCL_NONEXCLUSIVE | DISCL_FOREGROUND );
	hr = lpdiKeyboard->SetDataFormat(&c_dfDIKeyboard); 
	if (lpdiKeyboard) hr = lpdiKeyboard->Acquire(); 

	return hr;
}

void CleanDInput( ) {
	lpdiKeyboard->Unacquire();
	lpdiKeyboard->Release();
	lpdi->Release();
}
